# Race detection tool

This is a data race detection result from the paper: Efficient, context-sensitive and guarded data race detection.


## Experiment results.

It consists of two parts: tool comparison results and race detection results for real-world programs.

### Tool comparison.

Checking results are packed at directory "comparison".

### Reported races.

Due to the double-blind requirement, we only show the screenshot of bug reports.

Axel ([link](https://github.com/axel-download-accelerator/axel/tree/65fef5df6422e02aa349ed921b78eeeb66603ed4), confirmed). Its report is at Reports/axel.bc-bugs.txt
![alt text](images/axel.png)

Lunchbox ([link](https://github.com/Eyescale/Lunchbox/tree/1a9647853805a310dfa4d92598a21ea6cc0d72e2), confirmed). Its report is at Reports/Lunchbox-threadPool.bc-bug.txt
![alt text](images/Lunchbox.png)

rsyslog ([link](https://github.com/rsyslog/rsyslog/tree/6b8a54de970f49239f9e357375df80b3d981f6cc), confirmed). Its report is at Reports/rsyslog-imudp.so.bc-bug.txt
![alt text](images/rsyslog.png)

s3fs-fuse ([link](https://github.com/s3fs-fuse/s3fs-fuse/tree/fa8c4175260ffd15a5bcf4bb006d075c1d56f296), confirmed). Its report is at Reports/s3fs.bc-bug.txt
![alt text](images/s3fs-fuse.png)

sofa-pbrpc ([link](https://github.com/baidu/sofa-pbrpc/tree/daaa35bf12ae615fefe81ea913b17f56eabc69f6), confirmed). Its report is at Reports/sofa-pbrpc-client.bc-bug.txt
![alt text](images/sofa-pbrpc.png)

Finedb ([link](https://github.com/Amaury/FineDB/tree/70239aebc42e0ba47d4c12008814e47361f52106), confirmed). Its report is at Reports/FineDB-liblmdb.so.bc-bug.txt
![alt text](images/finedb.png)

transmission ([link](https://github.com/transmission/transmission/releases/tag/2.92), confirmed). Its report is at Reports/transmission-2.92-bugs.txt
![alt text](images/transmission.png)

leveldb ([link](https://github.com/google/leveldb/tree/8415f00eeedd96934d3578572d3802900e61a556), confirmed). Its report is at Reports/leveldb-db_test.bc-bug.txt 
![alt text](images/leveldb.png)

zfs ([this](https://github.com/zfsonlinux/zfs/tree/e3bdcb8ad88e7a90726193c9afe96a713729c928), no response). Its report is at Reports/zfs-zfs.bc-bug.txt
![alt text](images/zfs.png)

lwan ([this](https://github.com/lpereira/lwan/tree/2686a55194180f585e9d37d152663ddb8a429a8d), no response). Its report is at Reports/lwan.bc-bug.txt
![alt text](images/lwan.png)

zfs-fuse ([this](https://github.com/gordan-bobic/zfs-fuse/tree/5f140cec349a795ce56075053492eb450871de14), no response). Its report is at Reports/zfs-fuse-umem_test.bc-bug.txt
![alt text](images/zfs-fuse.png)

RedAlert ([this](https://github.com/alibaba/RedAlert/tree/fce1954550941891dde6b0471953ec95c918bb2a), no response). Its report is at Reports/RedAlert-RAServer-bugs.txt
![alt text](images/RedAlert.png)